**Publishing Android Application**
==================================

Android application publishing is a process that makes your Android applications
available to users. In fact, publishing is the last phase of the Android
application development process.

Once you developed and fully tested your Android Application, you can stat
selling or distributing free using Google Play (A famous Android marketplace).
You can also release your applications by sending them directly to users or by
letting users download them from your own website.

You can check a detailed publishing process at Android official website, but
this tutorial will take you through simple steps to launch your application on
Google Play. Here is a simplified check list which will help you in launching
your Android application:

| **Step** | **Activity**                                                                                                                                                                                                                                                                                                                                                                   |
|----------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 1        | **Regression Testing** Before you publish your application, you need to make sure that its meeting the basic quality expectations for all Android apps, on all of the devices that you are targeting. So perform all the required testing on different devices including phone and tablets.                                                                                    |
| 2        | **Application Rating** When you will publish your application at Google Play, you will have to specify a content rating for your app, which informs Google Play users of its maturity level. Currently available ratings are (a) Everyone (b) Low maturity (c) Medium maturity (d) High maturity.                                                                              |
| 3        | **Targeted Regions** Google Play lets you control what countries and territories where your application will be sold. Accordingly you must take care of setting up time zone, localization or any other specific requirement as per the targeted region.                                                                                                                       |
| 4        | **Application Size** Currently, the maximum size for an APK published on Google Play is 50 MB. If your app exceeds that size, or if you want to offer a secondary download, you can use APK Expansion Files, which Google Play will host for free on its server infrastructure and automatically handle the download to devices.                                               |
| 5        | **SDK and Screen Compatibility** It is important to make sure that your app is designed to run properly on the Android platform versions and device screen sizes that you want to target.                                                                                                                                                                                      |
| 6        | **Application Pricing** Deciding whether you app will be free or paid is important because, on Google Play, free apps must remain free. If you want to sell your application then you will have to specify its price in different currencies.                                                                                                                                  |
| 7        | **Promotional Content** It is a good marketing practice to supply a variety of high-quality graphic assets to showcase your app or brand. After you publish, these appear on your product details page, in store listings and search results, and elsewhere.                                                                                                                   |
| 8        | **Build and Upload release-ready APK** The release-ready APK is what you you will upload to the Developer Console and distribute to users. You can check complete detail on how to create a release-ready version of your app: [Preparing for Release](http://developer.android.com/tools/publishing/preparing.html).                                                          |
| 9        | **Finalize Application Detail** Google Play gives you a variety of ways to promote your app and engage with users on your product details page, from colorful graphics, screenshots, and videos to localized descriptions, release details, and links to your other apps. So you can decorate your application page and provide as much as clear crisp detail you can provide. |

 

**Export Android Application**
------------------------------

You will need to export your application as an APK (Android Package) file before
you upload it Google Play marketplace.

To export an application, just open that application project in Eclipse and
select **File-\>Export** from your Eclipse and follow the simple steps to export
your application:

Next select, **Export Android Application** option as shown in the above screen
shot and then click **Next** and again **Next** so that you get following screen
where you will choose **Create new keystore** to store your application.

Enter your password to protect your application and click on **Next** button
once again. It will display followig screen to let you create a key for your
application:

Once you filled up all the information, click **Next** button and finally it
will ask you a location where Application will be exported:

Finally, you click on **Finish** button to generate your Android Application
Package File which will be uploaded at Google Play marketplace.

**Google Play Registration**
----------------------------

The most important step is to register with Google Play using [Google Play
Marketplace](https://play.google.com/apps/publish/). You can use your existing
google ID if you have any otherwise you can create a new Google ID and then
register with the marketplace. You will have following screen to accept terms
and condition.

You can use **Continue to payment** button to proceed to make a payment of \$25
as a registration fee and finally to complete your account detail.

Once you are a registered user at Google Play, you can upload **release-ready
APK** for your application and finally you will complete application detail
using application detail page as mentioned in step 9 of the above mentioned
checklist.
