**Alert Box Example**
=====================

In this tutorial, we show you how to display an alert box in Android. See
flowing Steps :  
1. First, use the AlertDialog.Builder to create the alert box interface, like
title, message to display, buttons, and button onclick function  
2. Later attach above builder to AlertDialog and display it.  
3. Done.

<br>**1 Android Layout Files**
------------------------------

  
Simpel layout file, display a button on screen.  
File : res/layout/activity_main.xml

```xml
<?xml version="1.0" encoding="utf-8"?>
<LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
    android:layout_width="fill_parent"
    android:layout_height="fill_parent"
    android:gravity="center_horizontal"
    android:orientation="vertical">

    <Button
        android:id="@+id/buttonAlert"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:layout_margin="20dip"
        android:onClick="onClick"
        android:text="Show Alert Box" />
</LinearLayout>
```

 

**2. Activity**
---------------

  
When user click on this button, display the alert box, with your pre-defined
alert dialog interface.  
File : MainActivity.java

```java
package rk.tutorial.alert.dialog.example;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.view.View;

public class MainActivity extends Activity {
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    public void onClick(View view) {
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(MainActivity.this);
        // set title
        alertDialogBuilder.setTitle("Your Title");
        // set dialog message
        alertDialogBuilder.setMessage("Click yes to exit! No for Cancel dialog").setCancelable(false).setPositiveButton("Yes", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int id) {
                // if this button is clicked, close
                // current activity
                MainActivity.this.finish();
            }
        })
                .setNegativeButton("No", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        // if this button is clicked, just close
                        // the dialog box and do nothing
                        dialog.cancel();
                    }
                });
        // create alert dialog
        AlertDialog alertDialog = alertDialogBuilder.create();
        // show it
        alertDialog.show();
    }
}
```


**3.Demo**
----------

  
Display Screen

![Alert Box](file:///android_asset/img/Alert.png?raw=true "Alert Box")

![Alert Box](file:///android_asset/img/Alert-box.png?raw=true "Alert Box")

 
