**SQLite Expressions**
======================

An expression is a combination of one or more values, operators and SQL
functions that evaluate to a value.

SQL EXPRESSIONs are like formulas and they are written in query language. You
can also use to query the database for specific set of data.

### **Syntax:**

Consider the basic syntax of the SELECT statement as follows:

```sql
SELECT column1, column2, columnN
FROM table_name
WHERE [CONDITION | EXPRESSION];
```

There are different types of SQLite expressions, which are mentioned below:

**SQLite - Boolean Expressions:**
---------------------------------

SQLite Boolean Expressions fetch the data on the basis of matching single value.
Following is the syntax:

```sql
SELECT column1, column2, columnN
FROM table_name
WHERE SINGLE VALUE MATCHING EXPRESSION;
```

Consider COMPANY table has the following records:

```sql
ID          NAME        AGE         ADDRESS     SALARY
----------  ----------  ----------  ----------  ----------
1           Paul        32          California  20000.0
2           Allen       25          Texas       15000.0
3           Teddy       23          Norway      20000.0
4           Mark        25          Rich-Mond   65000.0
5           David       27          Texas       85000.0
6           Kim         22          South-Hall  45000.0
7           James       24          Houston     10000.0
```

Here is simple examples showing usage of SQLite Boolean Expressions:

```sql
sqlite> SELECT * FROM COMPANY WHERE SALARY = 10000;
 
ID          NAME        AGE         ADDRESS     SALARY
----------  ----------  ----------  ----------  ----------
4           James        24          Houston   10000.0
```

**SQLite - Numeric Expression:**
--------------------------------

These expressions are used to perform any mathematical operation in any query.
Following is the syntax:

```sql
SELECT numerical_expression as  OPERATION_NAME
[FROM table_name WHERE CONDITION] ;
```

Here, numerical_expression is used for mathematical expression or any formula.
Following is a simple example showing usage of SQLite Numeric Expressions:

```sql
sqlite> SELECT (15 + 6) AS ADDITION
ADDITION = 21
```

There are several built-in functions like avg(), sum(), count(), etc., to
perform what is known as aggregate data calculations against a table or a
specific table column.

```sql
sqlite> SELECT COUNT(*) AS "RECORDS" FROM COMPANY;
RECORDS = 7
```

**SQLite - Date Expressions:**
------------------------------

Date Expressions return current system date and time values and these
expressions will be used in various data manipulations.

```sql
sqlite>  SELECT CURRENT_TIMESTAMP;
CURRENT_TIMESTAMP = 2013-03-17 10:43:35
```
