**SQLite UPDATE Query**
=======================

The SQLite **UPDATE** Query is used to modify the existing records in a table.
You can use WHERE clause with UPDATE query to update selected rows, otherwise
all the rows would be updated.

**Syntax:**
-----------

The basic syntax of UPDATE query with WHERE clause is as follows:

```sql
UPDATE table_name
SET column1 = value1, column2 = value2...., columnN = valueN
WHERE [condition];
```

You can combine N number of conditions using AND or OR operators.

### **Example:**

**Consider COMPANY table is having the following records:**

```sql
ID          NAME        AGE         ADDRESS     SALARY
----------  ----------  ----------  ----------  ----------
1           Paul        32          California  20000.0
2           Allen       25          Texas       15000.0
3           Teddy       23          Norway      20000.0
4           Mark        25          Rich-Mond   65000.0
5           David       27          Texas       85000.0
6           Kim         22          South-Hall  45000.0
7           James       24          Houston     10000.0
```

**Following is an example, which would update ADDRESS for a customer whose ID is
6:**

```sql
sqlite> UPDATE COMPANY SET ADDRESS = 'Texas' WHERE ID = 6;
```

**Now, COMPANY table would have the following records:**

```sql
ID          NAME        AGE         ADDRESS     SALARY
----------  ----------  ----------  ----------  ----------
1           Paul        32          California  20000.0
2           Allen       25          Texas       15000.0
3           Teddy       23          Norway      20000.0
4           Mark        25          Rich-Mond   65000.0
5           David       27          Texas       85000.0
6           Kim         22          Texas       45000.0
7           James       24          Houston     10000.0
```

If you want to modify all ADDRESS and SALARY column values in COMPANY table, you
do not need to use WHERE clause and UPDATE query would be as follows:

```sql
sqlite> UPDATE COMPANY SET ADDRESS = 'Texas', SALARY = 20000.00;
```

**Now, COMPANY table will have the following records:**

```sql
ID          NAME        AGE         ADDRESS     SALARY
----------  ----------  ----------  ----------  ----------
1           Paul        32          Texas       20000.0
2           Allen       25          Texas       20000.0
3           Teddy       23          Texas       20000.0
4           Mark        25          Texas       20000.0
5           David       27          Texas       20000.0
6           Kim         22          Texas       20000.0
7           James       24          Texas       20000.0
```
